using System;
using System.Linq;
using System.Collections.Generic;

namespace sample
{
  class Sample
  {
    static void Main(string[] args)
    {
      List<int> values = new List<int>() { 1, 2, 3, 5, 4, 6, 7, 8, 9, 10};

      //Find the double of the first even number greater than 3
      int result = 0;
      foreach(var e in values) {
        if(e > 3 && e % 2 ==0) {
          result = e * 2;
          break;
        }
      }
      Console.WriteLine(result);
      
      Console.WriteLine(values.Where(e => e > 3).Where(e => e % 2 == 0).Select(e => e * 2).First());
      
      //In the above code, the expressions in Wheres and Select are run only the same number of times
      //as in the imperative code—save performance—this is lazy evaluation. Evaluation happens on demand
      //and only to the extent necessary. This would not make sense if the expressions had side-effect
      //the result would not be the same between eager and lazy evaluation in that case.
    }
  }
}

