using System;
using System.Linq;
using System.Collections.Generic;
using System.Diagnostics;

namespace sample
{
  class Sample
  {
    static bool IsPrime(int number) {
      return number > 1 &&
        !Enumerable.Range(2, number - 2).Any(i => number % i == 0);
    }
    
    static void TimeCode(Action block) {
      Stopwatch stopwatch = Stopwatch.StartNew();
      block();
      Console.WriteLine(stopwatch.Elapsed.TotalMilliseconds);
    }
    
    static void Main(string[] args)
    {
      const int MAX = 100000;
      
      TimeCode(() => 
        Console.WriteLine(Enumerable.Range(1, MAX).Where(IsPrime).ToList().Count));
        
        
      TimeCode(() => 
        Console.WriteLine(ParallelEnumerable.Range(1, MAX).Where(IsPrime).ToList().Count));
    }
  }
}









